/*    This class draws a water scene with fish

written by Scott McElfresh
*/


import java.awt.*;
import java.util.Random;
import javax.swing.*;


public class Picture extends JFrame
{
   
	private WindowCloser myCloser;
	private MouseTrap theMouse;
	private int sealevel;
	private Random R = new Random();
	private final static int REDGREENLINE1 = 1;
    private final static int REDGREENLINE2 = 2;
    private final static int YELLOWLINE = 3;
	private final static int YELLOWGREENLINE = 4;
	private final static int REDGREENLINEcomplete = 5;
    private final static int TENRANDOMrg = 6;
    private final static int TENRANDOMall = 7;
    private final static int TwentyRANDOMall = 8;
    private final static int LargeRANDOMall = 9;
    private final static int RANDOMplay = 10;

    //************
    // constructor for full size
	public Picture()
	{   
	   Rectangle R = getScreenBounds();
	   setSize((int)R.getWidth(),(int)R.getHeight());
	   setTitle("Fish program");
	   myCloser = new WindowCloser();
	   addWindowListener(myCloser);
	   theMouse = new MouseTrap();
	   addMouseListener(theMouse);
	   setVisible(true);
	} 
	//**********
	// constructor to specify width and height - automatically make the window visible
	// and allow it to be closed.
	public Picture(int width, int height)
	{
	   setSize(width,height);
	   setTitle("Fish program");
	   myCloser = new WindowCloser();
	   addWindowListener(myCloser);
	   theMouse = new MouseTrap();
	   addMouseListener(theMouse);
	   setVisible(true);
	}    
//***************
// this is called automatically by the system.
public void paint(Graphics g) 
{
}



// ******************************
// actually do the drawing, 
public void doDrawing(int choice)
{   Delayer.doDelay(1000);
    Graphics g = getGraphics();
    
    sealevel = 150;
    g.setColor(Color.cyan);
    g.fillRect(0,0,this.getWidth(),sealevel);
    
    g.setColor(Color.blue);
    g.fillRect(0,sealevel,this.getWidth(),this.getHeight()-sealevel);

    School allthefish = new School();
    fillSchool(allthefish,choice);
 
    switch (choice) 
    {
       case REDGREENLINE1:  
       case REDGREENLINE2: 
       case YELLOWGREENLINE:  
       case TENRANDOMrg: 
       case YELLOWLINE: 
               smallTestSuite(allthefish);
               break;
               
       case TENRANDOMall: 
       case TwentyRANDOMall: 
       case LargeRANDOMall: 
       case REDGREENLINEcomplete:
              fullTestSuite(allthefish);
              break;
              
       case RANDOMplay:
              doScreenSave(allthefish);
              break;
              
    }   
    
}

//*******************
public void doScreenSave(School allthefish)
{
    while (true)
    {
         if (theMouse.isPressed())
         {
             while (theMouse.isPressed())
             ;
             if (theMouse.getY() > sealevel + 15)
             {    Fish f = new Fish(theMouse.getX(), theMouse.getY(),FishColors.getRandomColor());
                  f.setFrame(this);
                  allthefish.add(f);
             }
         }
         allthefish.moveAll();
         for (int i = 0; i < allthefish.getHowMany(); i++)
         {  Fish thisone = allthefish.getFishAtPosition(i);
               if (! thisone.visible())
                {    thisone.reverseDirection();
                      for (int j = 0; j < 100 ; j++)
                           thisone.move();
                }
         }
         if (R.nextInt(1000) < 5)
         {    Fish thisone = allthefish.getFishAtPosition(R.nextInt(allthefish.getHowMany()));
              thisone.reverseDirection();
         }
    }
}
//*******
public void smallTestSuite(School allthefish)
{
     int times = 20;
     displayMessage("Click to see the fish move (the moveAll method is called " + times + " times)");
     waitForMouseClick();
     displayMessage("");
     for (int i = 0; i< times; i++)
     {    allthefish.moveAll();
          Delayer.doDelay(10);
     }
     //*****
     displayMessage("Click to see all green fish move");
     waitForMouseClick();
     displayMessage("");
     School onlygreen = allthefish.onecolor(new String("green"));
     for (int i = 0; i< times; i++)
     {    onlygreen.moveAll();
          Delayer.doDelay(10);
     }
     //*****
     displayMessage("Click to see all red fish move" );
     waitForMouseClick();
     displayMessage("");
     School onlyred = allthefish.onecolor(new String("red"));
     for (int i = 0; i< times; i++)
     {    onlyred.moveAll();
          Delayer.doDelay(10);
     }
    //*****
     displayMessage("Click to see all fish facing left move");
     waitForMouseClick();
     displayMessage("");
     School onlyleft = allthefish.onedirection(new String("left"));
     for (int i = 0; i< times; i++)
     {    onlyleft.moveAll();
          Delayer.doDelay(10);
     }
     //*****
     displayMessage("Click to see all fish facing right move");
     waitForMouseClick();
     displayMessage("");
     School onlyright = allthefish.onedirection(new String("right"));
     for (int i = 0; i< times; i++)
     {    onlyright.moveAll();
          Delayer.doDelay(10);
     }
     //*****     
     displayMessage("Click to see red fish reverse direction.");
     waitForMouseClick();
     displayMessage("");
     onlyred.reverseAll();
     //*****     
     displayMessage("Click to remove all red fish.");
     waitForMouseClick();
     displayMessage("");
     allthefish.removeAllOfColor(new String("red"));
     //*****     
     displayMessage("Click to see fish move offscreen one at a time.");
     waitForMouseClick();
     displayMessage("");
     for (int i = -1; i <= allthefish.getHowMany(); i++)
     {     allthefish.moveOffScreen(i);
     }   
}
//*******
public void fullTestSuite(School allthefish)
{
     int times = 20;
     displayMessage("Click to see the fish move (the moveAll method is called " + times + " times)");
     waitForMouseClick();
     displayMessage("");
     for (int i = 0; i< times; i++)
     {    allthefish.moveAll();
          Delayer.doDelay(10);
     }
     //*****
     for (int i = 0; i < 10; i ++)
     {  String color = FishColors.getRandomColor();
        displayMessage("Click to see all " + color + " fish move");
        waitForMouseClick();
        displayMessage("");
        School onlyone = allthefish.onecolor(color);
        for (int j = 0; j< times; j++)
        {    onlyone.moveAll();
             Delayer.doDelay(10);
        }
     }
    //*****
     displayMessage("Click to see all fish facing left move");
     waitForMouseClick();
     displayMessage("");
     School onlyleft = allthefish.onedirection(new String("left"));
     for (int i = 0; i< times; i++)
     {    onlyleft.moveAll();
          Delayer.doDelay(10);
     }
     //*****
     displayMessage("Click to see all fish facing right move");
     waitForMouseClick();
     displayMessage("");
     School onlyright = allthefish.onedirection(new String("right"));
     for (int i = 0; i< times; i++)
     {    onlyright.moveAll();
          Delayer.doDelay(10);
     }
     //*****   
     for (int i = 0; i < 10; i ++)
     {  String color = FishColors.getRandomColor();
        displayMessage("Click to see " + color + " fish reverse direction.");
        waitForMouseClick();
        displayMessage("");
        School onlyone = allthefish.onecolor(color);
        onlyone.reverseAll();
     }  
     //*****  
 
     for (int i = 0 ; i < 3; i++)
     {  
        String color = FishColors.getRandomColor();
        displayMessage("Click to remove all " + color + " fish.");
        waitForMouseClick();
        displayMessage("");
        allthefish.removeAllOfColor(color);
     } 
     String firstcolor =  null;
     while (allthefish.getHowMany() > 0)
     {  int which = R.nextInt(allthefish.getHowMany());
        String color = allthefish.getFishAtPosition(which).getColor();
        if (firstcolor == null)
           firstcolor = color;
        displayMessage("Click to remove all " + color + " fish.");
        waitForMouseClick();
        displayMessage("");
        allthefish.removeAllOfColor(color);
     } 
     String color = firstcolor;
     displayMessage("Click to remove all " + color + " fish.");
     waitForMouseClick();
     displayMessage("");
     allthefish.removeAllOfColor(color);   
     //*****     
     displayMessage("Click to see fish move offscreen one at a time.");
     waitForMouseClick();
     displayMessage("");
     for (int i = -1; i <= allthefish.getHowMany(); i++)
     {     allthefish.moveOffScreen(i);
     }   
}
//****************
// fill the school based on a case of the parameter
public void fillSchool(School theschool, int choice)
{  if (choice == REDGREENLINE1)
   { 
     for (int i = 0; i < 10; i++)
     {   int xcoord = this.getWidth()/2;
         int ycoord = sealevel + (i+1) * 40;  
         String color;
         if (i % 2 == 0)
             color = "red";
         else
              color= "green";
         Fish f = new Fish(xcoord, ycoord,color);
         f.setFrame(this);
         if (f.getFacingLeft())
            f.reverseDirection();
         theschool.add(f);
         flushGraphics();
     }
    }
   if (choice == YELLOWLINE)
   { 
     for (int i = 0; i < 10; i++)
     {   int xcoord = 500;
         int ycoord = sealevel + (i+1) * 40;  
         String color = "yellow";
         Fish f = new Fish(xcoord, ycoord,color);
         f.setFrame(this);
         if (f.getFacingLeft())
            f.reverseDirection();
         theschool.add(f);
         flushGraphics();
     }
    }
   if ((choice == REDGREENLINE2) || (choice == REDGREENLINEcomplete))
   { 
     for (int i = 0; i < 10; i++)
     {   int xcoord = this.getWidth()/2;
         int ycoord = sealevel + (i+1) * 40;  
         String color;
         if (i % 2 == 0)
             color = "red";
         else
              color= "green";
         Fish f = new Fish(xcoord, ycoord,color);
         f.setFrame(this); 
         theschool.add(f);
         flushGraphics();
     }
    }
   if (choice == YELLOWGREENLINE)
   { 
     for (int i = 0; i < 10; i++)
     {   int xcoord = this.getWidth()/2;
         int ycoord = sealevel + (i+1) * 40;  
         String color;
         if (i % 2 == 0)
             color = "yellow";
         else
              color= "green";
         Fish f = new Fish(xcoord, ycoord,color);
         f.setFrame(this);
         if (f.getFacingLeft())
            f.reverseDirection();
         theschool.add(f);
         flushGraphics();
     }
    }
   if (choice == TENRANDOMrg)
   { 
     for (int i = 0; i < 10; i++)
     {   int xcoord = R.nextInt(this.getWidth());
         int ycoord = R.nextInt(this.getHeight() - (sealevel + 15)) + (sealevel + 15);  
         String color;
         if (i %2 == 0)
             color = "red";
         else
              color= "green";
         Fish f = new Fish(xcoord, ycoord,color);
         f.setFrame(this);
         theschool.add(f);
         flushGraphics();
     }
   }
   if (choice == TENRANDOMall)
   { 
     for (int i = 0; i < 10; i++)
     {   int xcoord = R.nextInt(this.getWidth());
         int ycoord = R.nextInt(this.getHeight() - (sealevel + 15)) + (sealevel + 15);  
         String color = FishColors.getRandomColor();
         Fish f = new Fish(xcoord, ycoord,color);
         f.setFrame(this);
         theschool.add(f);
         flushGraphics();
     }
    }
   if (choice == TwentyRANDOMall)
   { 
     for (int i = 0; i < 20; i++)
     {   int xcoord = R.nextInt(this.getWidth());
         int ycoord = R.nextInt(this.getHeight() - (sealevel + 15)) + (sealevel + 15);  
         String color = FishColors.getRandomColor();
         Fish f = new Fish(xcoord, ycoord,color);
         f.setFrame(this);
         theschool.add(f);
         flushGraphics();
     }
    }
   if ((choice == LargeRANDOMall) || (choice == RANDOMplay))
   { 
     for (int i = 0; i < 35; i++)
     {   int xcoord = R.nextInt(this.getWidth());
         int ycoord = R.nextInt(this.getHeight() - (sealevel + 15)) + (sealevel + 15);  
         String color = FishColors.getRandomColor();
         Fish f = new Fish(xcoord, ycoord,color);
         f.setFrame(this);
         theschool.add(f);
         flushGraphics();
     }
    }
}
//***************
// put a message in the sky
private void displayMessage(String message)
{
    Graphics g = getGraphics();
    g.setColor(Color.cyan);
    g.fillRect(0,0,this.getWidth(),sealevel);
    g.setColor(Color.gray);
    g.drawString(message,100,100);


}
//***********
// do something silly to let the graphics flush
private void flushGraphics()
{
  for (int i = 0; i < 100; i++)
     getGraphics().drawLine(i,1,i,1);
}

//**** wait for user to hit and let go of mosue button
private void waitForMouseClick()
{
    while (! theMouse.isPressed())
       ;
    while (theMouse.isPressed())
       ;
   
}

//**********
private Rectangle getScreenBounds()
     {   GraphicsEnvironment ge = 
GraphicsEnvironment.getLocalGraphicsEnvironment();
                 GraphicsDevice gd =  ge.getDefaultScreenDevice();
                GraphicsConfiguration gc = gd.getDefaultConfiguration();
                 Rectangle R = gc.getBounds();

                 return R;
     }



}